#include <piece.h>
#include <string.h>
#include <musdef.h>

#define SECTOR_SIZE 4096	// PZN^̃TCY

#define INST_FILE "drum.bin"	// Ff[^t@C
#define SIZE_INST 39758		// Ff[^t@C̃TCY

// eFf[^̃TCY
#define SIZE_BD909    2641
#define SIZE_CYMBD    9795
#define SIZE_HANDCLAP 2153
#define SIZE_HC909    1427
#define SIZE_HO909    5665
#define SIZE_SD909    2254
#define SIZE_SDGATE   5823
#define SIZE_TOMH1    2360
#define SIZE_TOML1    4524
#define SIZE_TOMM1    3116

////////////////////////////////////////////////////////////////////////////////

// Fe[u
INST *inst[17];

// hȊỎF͂̂܂܎gp
extern INST i_square0;
extern INST i_saw0;
extern INST i_triangle0;
extern INST i_square;
extern INST i_saw;
extern INST i_triangle;

// hF
INST i_BD909    = {0, 0, 0, 0, PITCH16K, PITCH_C4, 0, 0, SIZE_BD909    << 14};
INST i_CYMBD    = {0, 0, 0, 0, PITCH16K, PITCH_C4, 0, 0, SIZE_CYMBD    << 14};
INST i_HANDCLAP = {0, 0, 0, 0, PITCH16K, PITCH_C4, 0, 0, SIZE_HANDCLAP << 14};
INST i_HC909    = {0, 0, 0, 0, PITCH16K, PITCH_C4, 0, 0, SIZE_HC909    << 14};
INST i_HO909    = {0, 0, 0, 0, PITCH16K, PITCH_C4, 0, 0, SIZE_HO909    << 14};
INST i_SD909    = {0, 0, 0, 0, PITCH16K, PITCH_C4, 0, 0, SIZE_SD909    << 14};
INST i_SDGATE   = {0, 0, 0, 0, PITCH16K, PITCH_C4, 0, 0, SIZE_SDGATE   << 14};
INST i_TOMH1    = {0, 0, 0, 0, PITCH16K, PITCH_C4, 0, 0, SIZE_TOMH1    << 14};
INST i_TOML1    = {0, 0, 0, 0, PITCH16K, PITCH_C4, 0, 0, SIZE_TOML1    << 14};
INST i_TOMM1    = {0, 0, 0, 0, PITCH16K, PITCH_C4, 0, 0, SIZE_TOMM1    << 14};

// t@Cǂݎpobt@
static signed char fileBuffer[SIZE_INST];

////////////////////////////////////////////////////////////////////////////////

int loadInst(void){
  FILEACC facc;
  int i, result;
  signed char *p;

  // Ff[^t@CΓǂݍ
  if(pceFileOpen(&facc, INST_FILE, FOMD_RD) == 0){
    result = 0;

    i = 0;
    while(i < SIZE_INST / SECTOR_SIZE){
      pceFileReadSct(&facc, fileBuffer + i * SECTOR_SIZE, i, SECTOR_SIZE);
      i++;
    }
    pceFileClose(&facc);
  }

  // Ff[^t@CȂΉFf[^OŖ߂
  else{
    result = 1;
    memset(fileBuffer, 0, SIZE_INST);
  }

  p = fileBuffer;
  i_BD909.pData = p;

  p += SIZE_BD909;
  i_CYMBD.pData = p;

  p += SIZE_CYMBD;
  i_HANDCLAP.pData = p;

  p += SIZE_HANDCLAP;
  i_HC909.pData = p;

  p += SIZE_HC909;
  i_HO909.pData = p;

  p += SIZE_HO909;
  i_SD909.pData = p;

  p += SIZE_SD909;
  i_SDGATE.pData = p;

  p += SIZE_SDGATE;
  i_TOMH1.pData = p;

  p += SIZE_TOMH1;
  i_TOML1.pData = p;

  p += SIZE_TOML1;
  i_TOMM1.pData = p;

  inst[ 0] = &i_square0;
  inst[ 1] = &i_saw0;
  inst[ 2] = &i_triangle0;
  inst[ 3] = &i_square;
  inst[ 4] = &i_saw;
  inst[ 5] = &i_triangle;
  inst[ 6] = &i_BD909;
  inst[ 7] = &i_SDGATE;
  inst[ 8] = &i_SD909;
  inst[ 9] = &i_HO909;
  inst[10] = &i_HC909;
  inst[11] = &i_CYMBD;
  inst[12] = &i_CYMBD;
  inst[13] = &i_TOMH1;
  inst[14] = &i_TOMM1;
  inst[15] = &i_TOML1;
  inst[16] = &i_HANDCLAP;

  return result;

}
